Index: design/admin/templates/content/diff.tpl
===================================================================
--- design/admin/templates/content/diff.tpl	(revision 22347)
+++ design/admin/templates/content/diff.tpl	(working copy)
@@ -124,7 +124,7 @@
 <div id="diffview">
 
 <script type="text/javascript">
-document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="#" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/admin/content/diff' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/admin/content/diff' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/admin/content/diff' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/admin/content/diff' )}</a></li></ul></div></div>');
+document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/admin/content/diff' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/admin/content/diff' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/admin/content/diff' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/admin/content/diff' )}</a></li></ul></div></div>');
 </script>
 
 {foreach $object.data_map as $attr}
Index: design/admin/templates/content/history.tpl
===================================================================
--- design/admin/templates/content/history.tpl	(revision 22347)
+++ design/admin/templates/content/history.tpl	(working copy)
@@ -449,7 +449,7 @@
 <div id="diffview">
 
 <script type="text/javascript">
-document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="#" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/admin/content/history' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/admin/content/history' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/admin/content/history' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/admin/content/history' )}</a></li></ul></div></div>');
+document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/admin/content/history' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/admin/content/history' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/admin/content/history' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/admin/content/history' )}</a></li></ul></div></div>');
 </script>
 
 {foreach $object.data_map as $attr}
Index: design/admin/templates/contentstructuremenu/content_structure_menu_dynamic.tpl
===================================================================
--- design/admin/templates/contentstructuremenu/content_structure_menu_dynamic.tpl	(revision 22347)
+++ design/admin/templates/contentstructuremenu/content_structure_menu_dynamic.tpl	(working copy)
@@ -155,7 +155,7 @@
         {
             html += '<a class="openclose-open" id="a'
                 + item.node_id
-                + '" href="#" onclick="this.blur(); return treeMenu.load( this, '
+                + '" href="javascript:void(0);" onclick="this.blur(); return treeMenu.load( this, '
                 + item.node_id
                 + ', '
                 + item.modified_subnode
@@ -230,7 +230,7 @@
         var icon = ( this.iconsList[classIdentifier] )? this.iconsList[classIdentifier]: this.iconsList['__default__'];
         if ( this.context != 'browse' )
         {
-            html += '<a class="nodeicon" href="#" onclick="ezpopmenu_showTopLevel( event, \'ContextMenu\', {\'%nodeID%\':'
+            html += '<a class="nodeicon" href="javascript:void(0);" onclick="ezpopmenu_showTopLevel( event, \'ContextMenu\', {\'%nodeID%\':'
                 + item.node_id
                 + ', \'%objectID%\':'
                 + item.object_id
Index: design/admin/templates/contentstructuremenu/show_content_structure.tpl
===================================================================
--- design/admin/templates/contentstructuremenu/show_content_structure.tpl	(revision 22347)
+++ design/admin/templates/contentstructuremenu/show_content_structure.tpl	(working copy)
@@ -25,7 +25,7 @@
 
             {* Fold/Unfold/Empty: [-]/[+]/[ ] *}
                 {section show=or($:haveChildren, $:isRootNode)}
-                   <a class="openclose" href="#" title="{'Fold/Unfold'|i18n('design/admin/contentstructuremenu')|wash}"
+                   <a class="openclose" href="javascript:void(0);" title="{'Fold/Unfold'|i18n('design/admin/contentstructuremenu')|wash}"
                       onclick="ezpopmenu_hideAll(); ezcst_onFoldClicked( this.parentNode ); return false;"></a>
                 {section-else}
                     <span class="openclose"></span>
@@ -35,7 +35,7 @@
             {section show=eq( $#ui_context, 'browse' )}
                 <a class="nodeicon" href="#">{$:parentNode.object.class_identifier|class_icon( $:classIconsSize )}</a>
             {section-else}
-                <a class="nodeicon" href="#" onclick="ezpopmenu_showTopLevel( event, 'ContextMenu', ez_createAArray( new Array( '%nodeID%', {$:parentNode.node.node_id}, '%objectID%', {$:parentNode.object.id}, '%languages%', {$:parentNode.object.language_js_array}, '%classList%', {$:canCreateClasses} ) ) , '{$:parentNode.object.name|shorten(18)|wash(javascript)}', {$:parentNode.node.node_id}, {cond( eq( $:canCreateClasses, "''" ), "'menu-create-here'", '-1' )} ); return false;">{$:parentNode.object.class_identifier|class_icon( $:classIconsSize, "[%classname] Click on the icon to display a context-sensitive menu."|i18n( 'design/admin/contentstructuremenu',, hash( '%classname', $:parentNode.object.class_name ) ) )}</a>
+                <a class="nodeicon" href="javascript:void(0);" onclick="ezpopmenu_showTopLevel( event, 'ContextMenu', ez_createAArray( new Array( '%nodeID%', {$:parentNode.node.node_id}, '%objectID%', {$:parentNode.object.id}, '%languages%', {$:parentNode.object.language_js_array}, '%classList%', {$:canCreateClasses} ) ) , '{$:parentNode.object.name|shorten(18)|wash(javascript)}', {$:parentNode.node.node_id}, {cond( eq( $:canCreateClasses, "''" ), "'menu-create-here'", '-1' )} ); return false;">{$:parentNode.object.class_identifier|class_icon( $:classIconsSize, "[%classname] Click on the icon to display a context-sensitive menu."|i18n( 'design/admin/contentstructuremenu',, hash( '%classname', $:parentNode.object.class_name ) ) )}</a>
             {/section}
             {* Label *}
                 {* Tooltip *}
Index: design/admin/templates/popupmenu/popup_menu.tpl
===================================================================
--- design/admin/templates/popupmenu/popup_menu.tpl	(revision 22347)
+++ design/admin/templates/popupmenu/popup_menu.tpl	(working copy)
@@ -37,7 +37,7 @@
 menuArray['CreateHereMenu']['elements'] = new Array();
 menuArray['CreateHereMenu']['elements']['menu-classes'] = new Array();
 menuArray['CreateHereMenu']['elements']['menu-classes']['variable'] = '%classList%';
-menuArray['CreateHereMenu']['elements']['menu-classes']['content'] = '<a id="menu-item-create-here" href="#" onclick="ezpopmenu_submitForm( \'menu-form-create-here\', new Array( \'classID\', \'%classID%\' ) ); return false;">%name%<\/a>';
+menuArray['CreateHereMenu']['elements']['menu-classes']['content'] = '<a id="menu-item-create-here" href="javascript:void(0);" onclick="ezpopmenu_submitForm( \'menu-form-create-here\', new Array( \'classID\', \'%classID%\' ) ); return false;">%name%<\/a>';
 
 {* Advanced menu *}
 menuArray['Advanced'] = new Array();
Index: design/admin/templates/toolbar/full/admin_bookmarks.tpl
===================================================================
--- design/admin/templates/toolbar/full/admin_bookmarks.tpl	(revision 22347)
+++ design/admin/templates/toolbar/full/admin_bookmarks.tpl	(working copy)
@@ -28,7 +28,7 @@
         {section show=ne( $ui_context, 'edit' )}
          <li>
        {section show=ne( $ui_context, 'browse')}
-       <a href="#" onclick="ezpopmenu_showTopLevel( event, 'BookmarkMenu', ez_createAArray( new Array( '%nodeID%', '{$Bookmarks.item.node_id}', '%objectID%', '{$Bookmarks.item.contentobject_id}', '%bookmarkID%', '{$Bookmarks.item.id}', '%languages%', {$Bookmarks.item.node.object.language_js_array} ) ) , '{$Bookmarks.item.name|shorten(18)|wash(javascript)}'); return false;">{$Bookmarks.item.node.object.content_class.identifier|class_icon( small, '[%classname] Click on the icon to display a context-sensitive menu.'|i18n( 'design/admin/pagelayout',, hash( '%classname', $Bookmarks.item.node.object.content_class.name  ) ) )}</a>&nbsp;<a href={$Bookmarks.item.node.url_alias|ezurl}>{$Bookmarks.item.node.name|wash}</a></li>
+       <a href="javascript:void(0);" onclick="ezpopmenu_showTopLevel( event, 'BookmarkMenu', ez_createAArray( new Array( '%nodeID%', '{$Bookmarks.item.node_id}', '%objectID%', '{$Bookmarks.item.contentobject_id}', '%bookmarkID%', '{$Bookmarks.item.id}', '%languages%', {$Bookmarks.item.node.object.language_js_array} ) ) , '{$Bookmarks.item.name|shorten(18)|wash(javascript)}'); return false;">{$Bookmarks.item.node.object.content_class.identifier|class_icon( small, '[%classname] Click on the icon to display a context-sensitive menu.'|i18n( 'design/admin/pagelayout',, hash( '%classname', $Bookmarks.item.node.object.content_class.name  ) ) )}</a>&nbsp;<a href={$Bookmarks.item.node.url_alias|ezurl}>{$Bookmarks.item.node.name|wash}</a></li>
        {section-else}
            {section show=$Bookmarks.item.node.object.content_class.is_container}
                {$Bookmarks.item.node.object.content_class.identifier|class_icon( small, $Bookmarks.item.node.object.content_class.name )}&nbsp;<a href={concat( '/content/browse/', $Bookmarks.item.node.node_id)|ezurl}>{$Bookmarks.item.node.name|wash}</a></li>
Index: design/standard/templates/content/diff.tpl
===================================================================
--- design/standard/templates/content/diff.tpl	(revision 22347)
+++ design/standard/templates/content/diff.tpl	(working copy)
@@ -124,7 +124,7 @@
 <div id="diffview">
 
 <script type="text/javascript">
-document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="#" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/standard/content/diff' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/standard/content/diff' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/standard/content/diff' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/standard/content/diff' )}</a></li></ul></div></div>');
+document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/standard/content/diff' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/standard/content/diff' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/standard/content/diff' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/standard/content/diff' )}</a></li></ul></div></div>');
 </script>
 
 {foreach $object.data_map as $attr}
Index: design/standard/templates/content/history.tpl
===================================================================
--- design/standard/templates/content/history.tpl	(revision 22347)
+++ design/standard/templates/content/history.tpl	(working copy)
@@ -391,7 +391,7 @@
 <div id="diffview">
 
 <script type="text/javascript">
-document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="#" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/standard/content/history' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/standard/content/history' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/standard/content/history' )}</a></li><li><a href="#" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/standard/content/history' )}</a></li></ul></div></div>');
+document.write('<div class="context-toolbar"><div class="block"><ul><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'previous\'); return false;">{'Old version'|i18n( 'design/standard/content/history' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'inlinechanges\'); return false;">{'Inline changes'|i18n( 'design/standard/content/history' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'blockchanges\'); return false;">{'Block changes'|i18n( 'design/standard/content/history' )}</a></li><li><a href="javascript:void(0);" onclick="show(\'diffview\', \'latest\'); return false;">{'New version'|i18n( 'design/standard/content/history' )}</a></li></ul></div></div>');
 </script>
 
 {foreach $object.data_map as $attr}
Index: design/standard/templates/contentstructuremenu/show_content_structure.tpl
===================================================================
--- design/standard/templates/contentstructuremenu/show_content_structure.tpl	(revision 22347)
+++ design/standard/templates/contentstructuremenu/show_content_structure.tpl	(working copy)
@@ -23,7 +23,7 @@
 
             {* Fold/Unfold/Empty: [-]/[+]/[ ] *}
                 {section show=or($:haveChildren, $:isRootNode)}
-                   <a class="openclose" href="#" title="{'Fold/Unfold'|i18n('design/standard/contentstructuremenu')}"
+                   <a class="openclose" href="javascript:void(0);" title="{'Fold/Unfold'|i18n('design/standard/contentstructuremenu')}"
                       onclick="ezcst_onFoldClicked( this.parentNode ); return false;"></a>
                 {section-else}
                     <span class="openclose"></span>