Index: kernel/classes/datatypes/ezuser/ezldapuser.php
===================================================================
--- kernel/classes/datatypes/ezuser/ezldapuser.php	(revision 23294)
+++ kernel/classes/datatypes/ezuser/ezldapuser.php	(working copy)
@@ -152,7 +152,7 @@
             $userID = $user->attribute( 'contentobject_id' );
 
             eZUser::updateLastVisit( $userID );
-            eZUser::setCurrentlyLoggedInUser( $user, $userID );
+            eZUser::setCurrentlyLoggedInUser( $user, $userID, true );
 
             // Reset number of failed login attempts
             eZUser::setFailedLoginAttempts( $userID, 0 );
@@ -659,7 +659,7 @@
 
                 if ( is_object( $existingUser ) )
                 {
-                    eZUser::setCurrentlyLoggedInUser( $existingUser, $existingUser->attribute( 'contentobject_id' ) );
+                    eZUser::setCurrentlyLoggedInUser( $existingUser, $existingUser->attribute( 'contentobject_id' ), true );
                 }
                 else
                 {
Index: kernel/classes/datatypes/ezuser/eztextfileuser.php
===================================================================
--- kernel/classes/datatypes/ezuser/eztextfileuser.php	(revision 23294)
+++ kernel/classes/datatypes/ezuser/eztextfileuser.php	(working copy)
@@ -161,7 +161,7 @@
             $userID = $user->attribute( 'contentobject_id' );
 
             eZUser::updateLastVisit( $userID );
-            eZUser::setCurrentlyLoggedInUser( $user, $userID );
+            eZUser::setCurrentlyLoggedInUser( $user, $userID, true );
 
             // Reset number of failed login attempts
             eZUser::setFailedLoginAttempts( $userID, 0 );
@@ -296,7 +296,7 @@
                             $user->store();
 
                             eZUser::updateLastVisit( $userID );
-                            eZUser::setCurrentlyLoggedInUser( $user, $userID );
+                            eZUser::setCurrentlyLoggedInUser( $user, $userID, true );
 
                             // Reset number of failed login attempts
                             eZUser::setFailedLoginAttempts( $userID, 0 );
@@ -340,7 +340,7 @@
                             }
 
                             eZUser::updateLastVisit( $userID );
-                            eZUser::setCurrentlyLoggedInUser( $existUser, $userID );
+                            eZUser::setCurrentlyLoggedInUser( $existUser, $userID, true );
 
                             // Reset number of failed login attempts
                             eZUser::setFailedLoginAttempts( $userID, 0 );
Index: kernel/classes/datatypes/ezuser/ezuser.php
===================================================================
--- kernel/classes/datatypes/ezuser/ezuser.php	(revision 23294)
+++ kernel/classes/datatypes/ezuser/ezuser.php	(working copy)
@@ -709,7 +709,7 @@
         eZAudit::writeAudit( 'user-login', array( 'User id' => $userID, 'User login' => $user->attribute( 'login' ) ) );
 
         eZUser::updateLastVisit( $userID, true );
-        eZUser::setCurrentlyLoggedInUser( $user, $userID );
+        eZUser::setCurrentlyLoggedInUser( $user, $userID, true );
 
         // Reset number of failed login attempts
         eZUser::setFailedLoginAttempts( $userID, 0 );
@@ -977,7 +977,7 @@
      All login handlers should use this function to ensure that the process
      is executed properly.
     */
-    static function setCurrentlyLoggedInUser( $user, $userID )
+    static function setCurrentlyLoggedInUser( $user, $userID, $regenerateSessionID = false )
     {
         $http = eZHTTPTool::instance();
 
@@ -988,7 +988,11 @@
         eZSession::setUserID( $userID );
         $http->setSessionVariable( 'eZUserLoggedInID', $userID );
         self::cleanup();
-        eZSession::regenerate();
+
+        if ( $regenerateSessionID )
+        {
+            eZSession::regenerate();
+        }
     }
 
     /*!
@@ -1200,7 +1204,7 @@
                     $http->setSessionVariable( 'eZUserLoggedInID', $userId );
 
                     eZUser::updateLastVisit( $currentUser->attribute( 'contentobject_id' ) );
-                    eZUser::setCurrentlyLoggedInUser( $currentUser, $currentUser->attribute( 'contentobject_id' ) );
+                    eZUser::setCurrentlyLoggedInUser( $currentUser, $currentUser->attribute( 'contentobject_id' ), true );
                     eZHTTPTool::redirect( eZSys::wwwDir() . eZSys::indexFile( false ) . eZSys::requestURI(), array(), 201 );
 
                 }
Index: kernel/setup/ezsetuptests.php
===================================================================
--- kernel/setup/ezsetuptests.php	(revision 23294)
+++ kernel/setup/ezsetuptests.php	(working copy)
@@ -913,6 +913,7 @@
     if ( $openBasedir != '' and
          $openBasedir != '.' )
     {
+        $returnData['result'] = false;
         $returnData['warnings'] = array( array( 'name' => 'open_basedir',
                                                 'text' => array( 'open_basedir is in use and can give problems running eZ Publish due to bugs in some PHP versions.',
                                                                  'It\'s recommended that it is turned off if you experience problems running eZ Publish.' ) ) );