Index: kernel/setup/ezsetuptests.php
===================================================================
--- kernel/setup/ezsetuptests.php	(revision 23357)
+++ kernel/setup/ezsetuptests.php	(working copy)
@@ -49,6 +49,7 @@
                   'curl_extension' => array( 'eZSetupTestExtension' ),
                   'zlib_extension' => array( 'eZSetupTestExtension' ),
                   'dom_extension' => array( 'eZSetupTestExtension' ),
+                  'iconv_extension' => array( 'eZSetupTestExtension' ),
                   'file_upload' => array( 'eZSetupTestFileUpload' ),
                   'open_basedir' => array( 'eZSetupTestOpenBasedir' ),
                   'safe_mode' => array( 'eZSetupTestSafeMode' ),
Index: settings/site.ini
===================================================================
--- settings/site.ini	(revision 23357)
+++ settings/site.ini	(working copy)
@@ -696,8 +696,8 @@
 # The pagelayout to use for first time setups
 PageLayout=setup_pagelayout.tpl
 # List of tests to be run, critical tests must pass for the setup to continue
-CriticalTests=variables_order;directory_permissions;phpversion;database_extensions;image_conversion;safe_mode;memory_limit;execution_time;magic_quotes_runtime;allow_url_fopen;accept_path_info;php_session;file_upload;zlib_extension;dom_extension;timezone;ezcversion
-OptionalTests=php_magicquotes;mbstring_extension;curl_extension;imagegd_extension;imagemagick_program;database_all_extensions;php_register_globals;texttoimage_functions;open_basedir
+CriticalTests=variables_order;directory_permissions;phpversion;database_extensions;image_conversion;safe_mode;memory_limit;execution_time;magic_quotes_runtime;allow_url_fopen;accept_path_info;php_session;file_upload;zlib_extension;dom_extension;iconv_extension;mbstring_extension;timezone;ezcversion
+OptionalTests=php_magicquotes;curl_extension;imagegd_extension;imagemagick_program;database_all_extensions;php_register_globals;texttoimage_functions;open_basedir
 OverrideSiteDesign=standard
 
 [RegionalSettings]
Index: settings/setup.ini
===================================================================
--- settings/setup.ini	(revision 23357)
+++ settings/setup.ini	(working copy)
@@ -74,6 +74,10 @@
 Extensions=curl
 Require=all
 
+[iconv_extension]
+Extensions=iconv
+Require=all
+
 [imagemagick_program]
 unix_Executable=convert
 unix_SearchPaths=/bin;/sbin;/usr/bin;/usr/sbin;/usr/local/bin;/usr/local/sbin
Index: design/standard/templates/setup/tests/iconv_extension_error.tpl
===================================================================
--- design/standard/templates/setup/tests/iconv_extension_error.tpl	(revision 23356)
+++ design/standard/templates/setup/tests/iconv_extension_error.tpl	(working copy)
@@ -1,8 +1,8 @@
 {* DO NOT EDIT THIS FILE! Use an override template instead. *}
-<h3>{$result_number}. {"Missing DOM extension"|i18n("design/standard/setup/tests")}</h3>
+<h3>{$result_number}. {"Missing iconv extension"|i18n("design/standard/setup/tests")}</h3>
 <p>
- {"The DOM extension is not available to eZ Publish. Without it eZ Publish will not work."|i18n("design/standard/setup/tests")}
+ {"The iconv extension is not available to eZ Publish. Without it eZ Publish will not work."|i18n("design/standard/setup/tests")}
 </p>
 <p>
- {'In most cases, the DOM extension is enabled by default because it is included in the PHP core. However, some Linux distributions have PHP without compiled-in support for DOM. Instead, they provide DOM as a shared module in a separate RPM package called "php-xml".'|i18n("design/standard/setup/tests")}
-</p>
\ No newline at end of file
+ {'In most cases, the iconv extension is enabled by default because it is included in the PHP core. However, some Linux distributions have PHP without compiled-in support for iconv. Instead, they provide iconv as a shared module in a separate RPM package called "php-iconv" (or "php5-iconv").'|i18n("design/standard/setup/tests")}
+</p>

Property changes on: design/standard/templates/setup/tests/iconv_extension_error.tpl
___________________________________________________________________
Added: svn:mergeinfo