Index: design/standard/templates/class/datatype/edit/ezmedia.tpl
===================================================================
--- design/standard/templates/class/datatype/edit/ezmedia.tpl	(revision 25272)
+++ design/standard/templates/class/datatype/edit/ezmedia.tpl	(working copy)
@@ -7,6 +7,8 @@
     <option value="real_player" {if eq( $class_attribute.data_text1, 'real_player' )}selected="selected"{/if}>{'RealPlayer'|i18n( 'design/standard/class/datatype' )}</option>
     <option value="silverlight" {if eq( $class_attribute.data_text1, 'silverlight' )}selected="selected"{/if}>{'Silverlight'|i18n( 'design/standard/class/datatype' )}</option>
     <option value="windows_media_player" {if eq( $class_attribute.data_text1, 'windows_media_player' )}selected="selected"{/if}>{'Windows Media Player'|i18n( 'design/standard/class/datatype' )}</option>
+    <option value="html5_video" {if eq( $class_attribute.data_text1, 'html5_video' )}selected="selected"{/if}>{'Html5 Video'|i18n( 'design/standard/class/datatype' )}</option>
+    <option value="html5_audio" {if eq( $class_attribute.data_text1, 'html5_audio' )}selected="selected"{/if}>{'Html5 Audio'|i18n( 'design/standard/class/datatype' )}</option>
 </select>
 </div>
 
Index: design/standard/templates/content/datatype/edit/ezmedia.tpl
===================================================================
--- design/standard/templates/content/datatype/edit/ezmedia.tpl	(revision 25272)
+++ design/standard/templates/content/datatype/edit/ezmedia.tpl	(working copy)
@@ -331,7 +331,78 @@
 </div>
 {/case}
 
+{* HTML5 Video *}
+{case match=html5_video}
+<div class="block">
+    <input type="hidden" name="MAX_FILE_SIZE" value="{$attribute.contentclass_attribute.data_int1|mul( 1024, 1024 )}" />
+    <label for="{$attribute_base}_media_{$attribute.id}_file">{'New file for upload'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input class="box" id="{$attribute_base}_media_{$attribute.id}_file" name="{$attribute_base}_data_mediafilename_{$attribute.id}" type="file" />
+</div>
+
+<div class="block">
+
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_width">{'Width'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input type="text" id="{$attribute_base}_media_{$attribute.id}_width" name="{$attribute_base}_data_media_width_{$attribute.id}" size="5" value="{$attribute.content.width}" />
+</div>
+
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_height">{'Height'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input type="text" id="{$attribute_base}_media_{$attribute.id}_height" name="{$attribute_base}_data_media_height_{$attribute.id}" size="5" value="{$attribute.content.height}" />
+    &nbsp;
+    &nbsp;
+    &nbsp;
+</div>
+
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_controller">{'Controller'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input id="{$attribute_base}_media_{$attribute.id}_controller" type="checkbox" name="{$attribute_base}_data_media_has_controller_{$attribute.id}" value="1" {if $attribute.content.has_controller}checked="checked"{/if} />
+</div>
 
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_autoplay">{'Autoplay'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input type="checkbox" id="{$attribute_base}_media_{$attribute.id}_autoplay" name="{$attribute_base}_data_media_is_autoplay_{$attribute.id}" value="1" {if $attribute.content.is_autoplay}checked="checked"{/if} />
+</div>
+
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_loop">{'Loop'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input type="checkbox" id="{$attribute_base}_media_{$attribute.id}_loop" name="{$attribute_base}_data_media_is_loop_{$attribute.id}" value="1" {if $attribute.content.is_loop}checked="checked"{/if} />
+</div>
+
+<div class="break"></div>
+</div>
+{/case}
+
+{* HTML5 Audio *}
+{case match=html5_audio}
+<div class="block">
+    <input type="hidden" name="MAX_FILE_SIZE" value="{$attribute.contentclass_attribute.data_int1|mul( 1024, 1024 )}" />
+    <label for="{$attribute_base}_media_{$attribute.id}_file">{'New file for upload'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input class="box" id="{$attribute_base}_media_{$attribute.id}_file" name="{$attribute_base}_data_mediafilename_{$attribute.id}" type="file" />
+</div>
+
+<div class="block">
+
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_controller">{'Controller'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input id="{$attribute_base}_media_{$attribute.id}_controller" type="checkbox" name="{$attribute_base}_data_media_has_controller_{$attribute.id}" value="1" {if $attribute.content.has_controller}checked="checked"{/if} />
+</div>
+
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_autoplay">{'Autoplay'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input type="checkbox" id="{$attribute_base}_media_{$attribute.id}_autoplay" name="{$attribute_base}_data_media_is_autoplay_{$attribute.id}" value="1" {if $attribute.content.is_autoplay}checked="checked"{/if} />
+</div>
+
+<div class="element">
+    <label for="{$attribute_base}_media_{$attribute.id}_loop">{'Loop'|i18n( 'design/standard/content/datatype' )}:</label>
+    <input type="checkbox" id="{$attribute_base}_media_{$attribute.id}_loop" name="{$attribute_base}_data_media_is_loop_{$attribute.id}" value="1" {if $attribute.content.is_loop}checked="checked"{/if} />
+</div>
+
+<div class="break"></div>
+</div>
+{/case}
+
+
 
 {/switch}
 
Index: design/standard/templates/content/datatype/view/ezmedia.tpl
===================================================================
--- design/standard/templates/content/datatype/view/ezmedia.tpl	(revision 25272)
+++ design/standard/templates/content/datatype/view/ezmedia.tpl	(working copy)
@@ -96,6 +96,26 @@
         <iframe style="visibility: hidden; height: 0; width: 0; border: 0px;"></iframe>
     </div>
     {/case}
+    {case match=html5_video}
+    <video src={concat("content/download/",$attribute.contentobject_id,"/",$attribute.content.contentobject_attribute_id,"/",$attribute.content.original_filename)|ezurl}
+               {if $attribute.content.width|gt( 0 )}width="{$attribute.content.width}"{/if}
+               {if $attribute.content.height|gt( 0 )}height="{$attribute.content.height}"{/if}
+               {if $attribute.content.is_autoplay}autoplay="autoplay"{/if}
+               {if $attribute.content.is_loop}loop="loop"{/if}
+               {if $attribute.content.has_controller}controls="controls"{/if}
+               preload="none">
+        {'Your browser does not support html5 video.'|i18n( 'design/standard/content/datatype' )}
+    </video>
+    {/case}
+    {case match=html5_audio}
+    <audio src={concat("content/download/",$attribute.contentobject_id,"/",$attribute.content.contentobject_attribute_id,"/",$attribute.content.original_filename)|ezurl}
+               {if $attribute.content.is_autoplay}autoplay="autoplay"{/if}
+               {if $attribute.content.is_loop}loop="loop"{/if}
+               {if $attribute.content.has_controller}controls="controls"{/if}
+               preload="none">
+        {'Your browser does not support html5 audio.'|i18n( 'design/standard/content/datatype' )}
+    </audio>
+    {/case}
     {/switch}
 
 {else}